CSIT-1477: add 1n_tx2 VPP Device
[csit.git] / resources / libraries / bash / function / common.sh
index 399b449..f1f0285 100644 (file)
@@ -23,7 +23,6 @@ set -exuo pipefail
 
 
 function activate_docker_topology () {
-    set -exuo pipefail
 
     # Create virtual vpp-device topology. Output of the function is topology
     # file describing created environment saved to a file.
@@ -34,9 +33,12 @@ function activate_docker_topology () {
     # - NODENESS - Node multiplicity of desired testbed.
     # - FLAVOR - Node flavor string, usually describing the processor.
     # - IMAGE_VER_FILE - Name of file that contains the image version.
+    # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
     # Variables set:
     # - WORKING_TOPOLOGY - Path to topology file.
 
+    set -exuo pipefail
+
     source "${BASH_FUNCTION_DIR}/device.sh" || {
         die "Source failed!"
     }
@@ -44,11 +46,11 @@ function activate_docker_topology () {
     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
     case_text="${NODENESS}_${FLAVOR}"
     case "${case_text}" in
-        "1n_skx")
+        "1n_skx" | "1n_tx2")
             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
             # script's functions. Env variables are read from ssh output
             # back to localhost for further processing.
-            hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3)
+            hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
             ssh="ssh root@${hostname} -p 6022"
             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
             # backtics to avoid https://midnight-commander.org/ticket/2142
@@ -91,8 +93,6 @@ function activate_docker_topology () {
 
 function activate_virtualenv () {
 
-    set -exuo pipefail
-
     # Update virtualenv pip package, delete and create virtualenv directory,
     # activate the virtualenv, install requirements, set PYTHONPATH.
 
@@ -107,10 +107,7 @@ function activate_virtualenv () {
     # Functions called:
     # - die - Print to stderr and exit.
 
-    # TODO: Do we want the callers to be able to set the env dir name?
-    # TODO: + In that case, do we want to support env switching?
-    # TODO:   + In that case we want to make env_dir global.
-    # TODO: Do we want the callers to override PYTHONPATH loaction?
+    set -exuo pipefail
 
     root_path="${1-$CSIT_DIR}"
     env_dir="${root_path}/env"
@@ -135,8 +132,6 @@ function activate_virtualenv () {
 
 function archive_tests () {
 
-    set -exuo pipefail
-
     # Create .tar.xz of generated/tests for archiving.
     # To be run after generate_tests, kept separate to offer more flexibility.
 
@@ -145,6 +140,8 @@ function archive_tests () {
     # File rewriten:
     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
 
+    set -exuo pipefail
+
     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
         die "Error creating archive of generated tests."
     }
@@ -153,10 +150,7 @@ function archive_tests () {
 
 function check_download_dir () {
 
-    set -exuo pipefail
-
     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
-    # TODO: Do we need this as a function, if it is (almost) a one-liner?
     #
     # Variables read:
     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
@@ -165,6 +159,8 @@ function check_download_dir () {
     # Functions called:
     # - die - Print to stderr and exit.
 
+    set -exuo pipefail
+
     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
         die "No artifacts downloaded!"
     fi
@@ -173,12 +169,12 @@ function check_download_dir () {
 
 function cleanup_topo () {
 
-    set -exuo pipefail
-
     # Variables read:
     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
 
+    set -exuo pipefail
+
     python "${PYTHON_SCRIPTS_DIR}/topo_cleanup.py" -t "${WORKING_TOPOLOGY}"
     # Not using "|| die" as some callers might want to ignore errors,
     # e.g. in teardowns, such as unreserve.
@@ -187,8 +183,6 @@ function cleanup_topo () {
 
 function common_dirs () {
 
-    set -exuo pipefail
-
     # Set global variables, create some directories (without touching content).
 
     # Variables set:
@@ -206,6 +200,8 @@ function common_dirs () {
     # Functions called:
     # - die - Print to stderr and exit.
 
+    set -exuo pipefail
+
     BASH_FUNCTION_DIR="$(dirname "$(readlink -e "${BASH_SOURCE[0]}")")" || {
         die "Some error during localizing this source directory."
     }
@@ -245,8 +241,6 @@ function common_dirs () {
 
 function compose_pybot_arguments () {
 
-    set -exuo pipefail
-
     # Variables read:
     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
     # - DUT - CSIT test/ subdirectory, set while processing tags.
@@ -257,6 +251,8 @@ function compose_pybot_arguments () {
     # - PYBOT_ARGS - String holding part of all arguments for pybot.
     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
 
+    set -exuo pipefail
+
     # No explicit check needed with "set -u".
     PYBOT_ARGS=("--loglevel" "TRACE")
     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
@@ -288,8 +284,10 @@ function compose_pybot_arguments () {
 
 function copy_archives () {
 
-    set -exuo pipefail
-
+    # Create additional archive if workspace variable is set.
+    # This way if script is running in jenkins all will be
+    # automatically archived to logs.fd.io.
+    #
     # Variables read:
     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
     #   Can be unset, then it speeds up manual testing.
@@ -300,9 +298,8 @@ function copy_archives () {
     # Functions called:
     # - die - Print to stderr and exit.
 
-    # We will create additional archive if workspace variable is set.
-    # This way if script is running in jenkins all will be
-    # automatically archived to logs.fd.io.
+    set -exuo pipefail
+
     if [[ -n "${WORKSPACE-}" ]]; then
         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
@@ -311,6 +308,7 @@ function copy_archives () {
 
 
 function deactivate_docker_topology () {
+
     # Deactivate virtual vpp-device topology by removing containers.
     #
     # Variables read:
@@ -321,10 +319,10 @@ function deactivate_docker_topology () {
 
     case_text="${NODENESS}_${FLAVOR}"
     case "${case_text}" in
-        "1n_skx")
-            hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3)
+        "1n_skx" | "1n_tx2")
+            hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
             ssh="ssh root@${hostname} -p 6022"
-            env_vars="$(env | grep CSIT_ | tr '\n' ' ' )"
+            env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
                 die "Topology cleanup via shim-dcr failed!"
             }
@@ -343,6 +341,7 @@ function deactivate_docker_topology () {
 
 
 function die () {
+
     # Print the message to standard error end exit with error code specified
     # by the second argument.
     #
@@ -361,8 +360,6 @@ function die () {
 
 function die_on_pybot_error () {
 
-    set -exuo pipefail
-
     # Source this fragment if you want to abort on any failed test case.
     #
     # Variables read:
@@ -370,6 +367,8 @@ function die_on_pybot_error () {
     # Functions called:
     # - die - Print to stderr and exit.
 
+    set -exuo pipefail
+
     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
     fi
@@ -378,8 +377,6 @@ function die_on_pybot_error () {
 
 function generate_tests () {
 
-    set -exuo pipefail
-
     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
     # The generation is done by executing any *.py executable
@@ -393,8 +390,10 @@ function generate_tests () {
     # Directories replaced:
     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
 
-    rm -rf "${GENERATED_DIR}/tests"
-    cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests"
+    set -exuo pipefail
+
+    rm -rf "${GENERATED_DIR}/tests" || die
+    cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
     cmd_line+=("-executable" "-name" "*.py")
     file_list=$("${cmd_line[@]}") || die
@@ -411,8 +410,6 @@ function generate_tests () {
 
 function get_test_code () {
 
-    set -exuo pipefail
-
     # Arguments:
     # - ${1} - Optional, argument of entry script (or empty as unset).
     #   Test code value to override job name from environment.
@@ -423,6 +420,8 @@ function get_test_code () {
     # - NODENESS - Node multiplicity of desired testbed.
     # - FLAVOR - Node flavor string, usually describing the processor.
 
+    set -exuo pipefail
+
     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
     if [[ -z "${TEST_CODE}" ]]; then
         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
@@ -437,6 +436,10 @@ function get_test_code () {
             NODENESS="1n"
             FLAVOR="skx"
             ;;
+       *"1n-tx2"*)
+            NODENESS="1n"
+            FLAVOR="tx2"
+            ;;
         *"2n-skx"*)
             NODENESS="2n"
             FLAVOR="skx"
@@ -445,6 +448,14 @@ function get_test_code () {
             NODENESS="3n"
             FLAVOR="skx"
             ;;
+        *"2n-dnv"*)
+            NODENESS="2n"
+            FLAVOR="dnv"
+            ;;
+        *"3n-dnv"*)
+            NODENESS="3n"
+            FLAVOR="dnv"
+            ;;
         *"3n-tsh"*)
             NODENESS="3n"
             FLAVOR="tsh"
@@ -460,18 +471,18 @@ function get_test_code () {
 
 function get_test_tag_string () {
 
-    set -exuo pipefail
-
     # Variables read:
     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
     # - TEST_CODE - The test selection string from environment or argument.
     # Variables set:
-    # - TEST_TAG_STRING - The string following "perftest" in gerrit comment,
-    #   or empty.
+    # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
+    #   May be empty, not set on event types not adding comment.
 
     # TODO: ci-management scripts no longer need to perform this.
 
+    set -exuo pipefail
+
     trigger=""
     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
         case "${TEST_CODE}" in
@@ -491,6 +502,7 @@ function get_test_tag_string () {
                 comment="${comment/perftest-3n/perftest}"
                 comment="${comment/perftest-hsw/perftest}"
                 comment="${comment/perftest-skx/perftest}"
+                comment="${comment/perftest-dnv/perftest}"
                 comment="${comment/perftest-tsh/perftest}"
                 tag_string="$(echo "${comment}" \
                     | grep -oE '(perftest$|perftest[[:space:]].+$)' || true)"
@@ -504,29 +516,42 @@ function get_test_tag_string () {
 }
 
 
-function reserve_testbed () {
-
-    set -exuo pipefail
+function reserve_and_cleanup_testbed () {
 
     # Reserve physical testbed, perform cleanup, register trap to unreserve.
+    # When cleanup fails, remove from topologies and keep retrying
+    # until all topologies are removed.
     #
     # Variables read:
     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
+    # - BUILD_TAG - Any string suitable as filename, identifying
+    #   test run executing this function. May be unset.
+    # - BUILD_URL - Any string suitable as URL, identifying
+    #   test run executing this function. May be unset.
     # Variables set:
+    # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
     # Functions called:
     # - die - Print to stderr and exit.
     # Traps registered:
     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
 
-    while true; do
+    set -exuo pipefail
+
+    while [[ ${TOPOLOGIES[@]} ]]; do
         for topo in "${TOPOLOGIES[@]}"; do
             set +e
-            python "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -t "${topo}"
+            scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
+            opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
+            opts+=("-u" "${BUILD_URL:-Unknown}")
+            python "${scrpt}" "${opts[@]}"
             result="$?"
             set -e
             if [[ "${result}" == "0" ]]; then
+                # Trap unreservation before cleanup check,
+                # so multiple jobs showing failed cleanup improve chances
+                # of humans to notice and fix.
                 WORKING_TOPOLOGY="${topo}"
                 echo "Reserved: ${WORKING_TOPOLOGY}"
                 trap "untrap_and_unreserve_testbed" EXIT || {
@@ -536,9 +561,28 @@ function reserve_testbed () {
                     }
                     die "Trap attempt failed, unreserve succeeded. Aborting."
                 }
-                cleanup_topo || {
-                    die "Testbed cleanup failed."
-                }
+                # Cleanup check.
+                set +e
+                cleanup_topo
+                result="$?"
+                set -e
+                if [[ "${result}" == "0" ]]; then
+                    break
+                fi
+                warn "Testbed cleanup failed: ${topo}"
+                untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
+                # WORKING_TOPOLOGY is now empty again.
+                # Build new topology array.
+                #   TOPOLOGIES=("${TOPOLOGIES[@]/$topo}")
+                # does not really work, see:
+                # https://stackoverflow.com/questions/16860877/remove-an-element-from-a-bash-array
+                new_topologies=()
+                for item in "${TOPOLOGIES[@]}"; do
+                    if [[ "${item}" != "${topo}" ]]; then
+                        new_topologies+=("${item}")
+                    fi
+                done
+                TOPOLOGIES=("${new_topologies[@]}")
                 break
             fi
         done
@@ -555,13 +599,18 @@ function reserve_testbed () {
         echo "Sleeping ${sleep_time}"
         sleep "${sleep_time}" || die "Sleep failed."
     done
+    if [[ ${TOPOLOGIES[@]} ]]; then
+        echo "Reservation and cleanup successful."
+    else
+        die "Run out of operational testbeds!"
+    fi
 }
 
 
 function run_pybot () {
 
-    set -exuo pipefail
-
+    # Run pybot with options based on input variables. Create output_info.xml
+    #
     # Variables read:
     # - CSIT_DIR - Path to existing root of local CSIT git repository.
     # - ARCHIVE_DIR - Path to store robot result files in.
@@ -572,12 +621,14 @@ function run_pybot () {
     # Functions called:
     # - die - Print to stderr and exit.
 
+    set -exuo pipefail
+
     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
+    all_options+=("--noncritical" "EXPECTED_FAILING")
     all_options+=("${EXPANDED_TAGS[@]}")
 
     pushd "${CSIT_DIR}" || die "Change directory operation failed."
     set +e
-    # TODO: Make robot tests not require "$(pwd)" == "${CSIT_DIR}".
     pybot "${all_options[@]}" "${GENERATED_DIR}/tests/"
     PYBOT_EXIT_STATUS="$?"
     set -e
@@ -588,24 +639,25 @@ function run_pybot () {
     all_options+=("--report" "none")
     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
     all_options+=("${ARCHIVE_DIR}/output.xml")
-    rebot "${all_options[@]}"
+    rebot "${all_options[@]}" || true
     popd || die "Change directory operation failed."
 }
 
 
 function select_tags () {
 
-    set -exuo pipefail
-
     # Variables read:
     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
     # - TEST_CODE - String affecting test selection, usually jenkins job name.
     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
     #   Can be unset.
     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
+    # - BASH_FUNCTION_DIR - Directory with input files to process.
     # Variables set:
     # - TAGS - Array of processed tag boolean expressions.
 
+    set -exuo pipefail
+
     # NIC SELECTION
     start_pattern='^  TG:'
     end_pattern='^ \? \?[A-Za-z0-9]\+:'
@@ -618,37 +670,44 @@ function select_tags () {
     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
                | grep -hoP "model: \K.*" | sort -u)
     # All topologies DUT NICs - Selected topology DUT NICs
-    exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}")))
+    exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
+        die "Computation of excluded NICs failed."
+    }
 
-    # Select default NIC
+    # Select default NIC tag.
     case "${TEST_CODE}" in
+        *"3n-dnv"* | *"2n-dnv"*)
+            default_nic="nic_intel-x553"
+            ;;
         *"3n-tsh"*)
-            DEFAULT_NIC='nic_intel-x520-da2'
+            default_nic="nic_intel-x520-da2"
             ;;
         *)
-            DEFAULT_NIC='nic_intel-x710'
+            default_nic="nic_intel-x710"
             ;;
     esac
 
+    # Tag file directory shorthand.
+    tfd="${BASH_FUNCTION_DIR}"
     case "${TEST_CODE}" in
         # Select specific performance tests based on jenkins job type variable.
         *"ndrpdr-weekly"* )
-            readarray -t test_tag_array < "${BASH_FUNCTION_DIR}/mlr-weekly.txt"
+            readarray -t test_tag_array < "${tfd}/mlr-weekly.txt" || die
             ;;
         *"mrr-daily"* )
-            readarray -t test_tag_array < "${BASH_FUNCTION_DIR}/mrr-daily.txt"
+            readarray -t test_tag_array < "${tfd}/mrr-daily.txt" || die
             ;;
         *"mrr-weekly"* )
-            readarray -t test_tag_array < "${BASH_FUNCTION_DIR}/mrr-weekly.txt"
+            readarray -t test_tag_array < "${tfd}/mrr-weekly.txt" || die
             ;;
         * )
             if [[ -z "${TEST_TAG_STRING-}" ]]; then
                 # If nothing is specified, we will run pre-selected tests by
                 # following tags.
-                test_tag_array=("mrrAND${DEFAULT_NIC}AND1cAND64bANDip4base"
-                                "mrrAND${DEFAULT_NIC}AND1cAND78bANDip6base"
-                                "mrrAND${DEFAULT_NIC}AND1cAND64bANDl2bdbase"
-                                "mrrAND${DEFAULT_NIC}AND1cAND64bANDl2xcbase"
+                test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
+                                "mrrAND${default_nic}AND1cAND78bANDip6base"
+                                "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
+                                "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
                                 "!dot1q" "!drv_avf")
             else
                 # If trigger contains tags, split them into array.
@@ -658,11 +717,11 @@ function select_tags () {
     esac
 
     # Blacklisting certain tags per topology.
+    #
+    # Reasons for blacklisting:
+    # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
+    # TODO: Add missing reasons here (if general) or where used (if specific).
     case "${TEST_CODE}" in
-        *"3n-hsw"*)
-            test_tag_array+=("!drv_avf")
-            test_tag_array+=("!ipsechwNOTnic_intel-xl710")
-            ;;
         *"2n-skx"*)
             test_tag_array+=("!ipsechw")
             ;;
@@ -671,6 +730,19 @@ function select_tags () {
             # Not enough nic_intel-xxv710 to support double link tests.
             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
             ;;
+        *"2n-dnv"*)
+            test_tag_array+=("!ipsechw")
+            test_tag_array+=("!memif")
+            test_tag_array+=("!srv6_proxy")
+            test_tag_array+=("!vhost")
+            test_tag_array+=("!vts")
+            ;;
+        *"3n-dnv"*)
+            test_tag_array+=("!memif")
+            test_tag_array+=("!srv6_proxy")
+            test_tag_array+=("!vhost")
+            test_tag_array+=("!vts")
+            ;;
         *"3n-tsh"*)
             test_tag_array+=("!ipsechw")
             test_tag_array+=("!memif")
@@ -678,9 +750,21 @@ function select_tags () {
             test_tag_array+=("!vhost")
             test_tag_array+=("!vts")
             ;;
+        *"3n-hsw"*)
+            # TODO: Introduce NOIOMMU version of AVF tests.
+            # TODO: Make (both) AVF tests work on Haswell,
+            # or document why (some of) it is not possible.
+            # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
+            test_tag_array+=("!drv_avf")
+            # All cards have access to QAT. But only one card (xl710)
+            # resides in same NUMA as QAT. Other cards must go over QPI
+            # which we do not want to even run.
+            test_tag_array+=("!ipsechwNOTnic_intel-xl710")
+            ;;
         *)
             # Default to 3n-hsw due to compatibility.
             test_tag_array+=("!drv_avf")
+            test_tag_array+=("!ipsechwNOTnic_intel-xl710")
             ;;
     esac
 
@@ -699,7 +783,7 @@ function select_tags () {
         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
             prefix="${prefix}mrrAND"
         else
-            prefix="${prefix}mrrAND${DEFAULT_NIC}AND"
+            prefix="${prefix}mrrAND${default_nic}AND"
         fi
     fi
     for tag in "${test_tag_array[@]}"; do
@@ -718,8 +802,6 @@ function select_tags () {
 
 function select_vpp_device_tags () {
 
-    set -exuo pipefail
-
     # Variables read:
     # - TEST_CODE - String affecting test selection, usually jenkins job name.
     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
@@ -727,6 +809,8 @@ function select_vpp_device_tags () {
     # Variables set:
     # - TAGS - Array of processed tag boolean expressions.
 
+    set -exuo pipefail
+
     case "${TEST_CODE}" in
         # Select specific performance tests based on jenkins job type variable.
         * )
@@ -744,7 +828,7 @@ function select_vpp_device_tags () {
 
     TAGS=()
 
-    # We will prefix with perftest to prevent running other tests
+    # We will prefix with devicetest to prevent running other tests
     # (e.g. Functional).
     prefix="devicetestAND"
     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
@@ -763,37 +847,37 @@ function select_vpp_device_tags () {
 
 function select_os () {
 
-    set -exuo pipefail
-
-    # Variables read:
-    # - OS - os or distro for selecting container image.
     # Variables set:
     # - VPP_VER_FILE - Name of File in CSIT dir containing vpp stable version.
     # - IMAGE_VER_FILE - Name of File in CSIT dir containing the image name.
     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
 
-    case "${OS}" in
-    "ubuntu"*)
-        IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
-        VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
-        PKG_SUFFIX="deb"
-        ;;
-    "centos"*)
-        IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
-        VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
-        PKG_SUFFIX="rpm"
-        ;;
-    *)
-        die "Unable to identify distro or os from ${OS}"
-        ;;
+    set -exuo pipefail
+
+    os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
+        die "Get OS release failed."
+    }
+
+    case "${os_id}" in
+        "ubuntu"*)
+            IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
+            VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
+            PKG_SUFFIX="deb"
+            ;;
+        "centos"*)
+            IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
+            VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
+            PKG_SUFFIX="rpm"
+            ;;
+        *)
+            die "Unable to identify distro or os from ${OS}"
+            ;;
     esac
 }
 
 
 function select_topology () {
 
-    set -exuo pipefail
-
     # Variables read:
     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
@@ -805,13 +889,17 @@ function select_topology () {
     # Functions called:
     # - die - Print to stderr and exit.
 
+    set -exuo pipefail
+
     case_text="${NODENESS}_${FLAVOR}"
     case "${case_text}" in
+        # TODO: Move tags to "# Blacklisting certain tags per topology" section.
+        # TODO: Double link availability depends on NIC used.
         "1n_vbox")
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
             TOPOLOGIES_TAGS="2_node_single_link_topo"
             ;;
-        "1n_skx")
+        "1n_skx" | "1n_tx2")
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
             TOPOLOGIES_TAGS="2_node_single_link_topo"
             ;;
@@ -823,6 +911,14 @@ function select_topology () {
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
             TOPOLOGIES_TAGS="3_node_*_link_topo"
             ;;
+        "2n_dnv")
+            TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
+            TOPOLOGIES_TAGS="2_node_single_link_topo"
+            ;;
+        "3n_dnv")
+            TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
+            TOPOLOGIES_TAGS="3_node_single_link_topo"
+            ;;
         "3n_hsw")
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
             TOPOLOGIES_TAGS="3_node_single_link_topo"
@@ -844,6 +940,7 @@ function select_topology () {
 
 
 function untrap_and_unreserve_testbed () {
+
     # Use this as a trap function to ensure testbed does not remain reserved.
     # Perhaps call directly before script exit, to free testbed for other jobs.
     # This function is smart enough to avoid multiple unreservations (so safe).
@@ -882,10 +979,13 @@ function untrap_and_unreserve_testbed () {
 
 
 function warn () {
+
     # Print the message to standard error.
     #
     # Arguments:
     # - ${@} - The text of the message.
 
+    set -exuo pipefail
+
     echo "$@" >&2
 }